#!/bin/sh

set -e

if [ "$(id -un)" != "www-data" ]; then
	echo "run this as user www-data only" >&2
	exit 1
fi


echo "Content-Type: text/html"
echo
echo "<pre>"

umask 0002

cd /osgeo/download/osgeo4w/v1
exec 2>>/tmp/osgeo4w-promote.log

if ! lockfile -l 600 .lock/regen.lock; then
	echo Locking failed
	exit 1
fi

trap "rm -f $PWD/.lock/regen.lock" EXIT

date >&2

echo "</pre>"

echo "<h1>Changes</h1>"

echo "<table border=1>"

for arch in x86 x86_64; do
	echo "<tr><th>$arch</th><td><pre>"
	cd $arch
	cp setup.ini setup.ini.prev
	cp setup_test.ini setup.ini
	cp setup_test.ini.bz2 setup.ini.bz2
	diff -u setup.ini.prev setup.ini && echo -n "(none)" || true
	../versions.pl "current $arch packages" setup.ini >versions.html
	../htmldiff versions_test.html versions.html >versions_diff.html
	cd ..
	echo "</pre></td></tr>"
done

./htmldiff x86/versions.html x86_64/versions.html >versions_diff-x86-x86_64.html

echo "</table><pre>"

xargs -P4 -n1 wget -q -O/dev/null -i - <<EOF >&2
http://buten.norbit.de/~jef/u/cgi-bin/mirror-osgeo4w.cgi
http://ci.oslandia.net/osgeo4w-scripts/mirror-sync.cgi
http://qgis.org/~jef/cgi-bin/update-sha.cgi
EOF

./update-symstores.sh

echo "</pre>"
